VERSION 5.00
Begin VB.Form frmUnpacker 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Unpacker by The trick"
   ClientHeight    =   1500
   ClientLeft      =   150
   ClientTop       =   765
   ClientWidth     =   6525
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1500
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   390
      Left            =   5250
      TabIndex        =   8
      Top             =   975
      Width           =   1200
   End
   Begin VB.ComboBox cboBits 
      Height          =   315
      ItemData        =   "frmUnpacker.frx":0000
      Left            =   1830
      List            =   "frmUnpacker.frx":001C
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1035
      Width           =   3270
   End
   Begin VB.CommandButton cmdPath 
      Caption         =   "..."
      Height          =   390
      Left            =   5250
      TabIndex        =   4
      Top             =   525
      Width           =   1200
   End
   Begin VB.TextBox txtPath 
      Height          =   345
      Left            =   1830
      TabIndex        =   3
      Top             =   570
      Width           =   3270
   End
   Begin VB.CommandButton cmdContainer 
      Caption         =   "..."
      Height          =   390
      Left            =   5250
      TabIndex        =   1
      Top             =   60
      Width           =   1200
   End
   Begin VB.TextBox txtSource 
      Height          =   345
      Left            =   1830
      TabIndex        =   0
      Top             =   105
      Width           =   3270
   End
   Begin VB.Label lblLabel 
      Caption         =   "Bitness:"
      Height          =   255
      Index           =   2
      Left            =   135
      TabIndex        =   6
      Top             =   1080
      Width           =   1620
   End
   Begin VB.Label lblLabel 
      Caption         =   "Output path:"
      Height          =   255
      Index           =   1
      Left            =   135
      TabIndex        =   5
      Top             =   615
      Width           =   1620
   End
   Begin VB.Label lblLabel 
      Caption         =   "Container:"
      Height          =   255
      Index           =   0
      Left            =   135
      TabIndex        =   2
      Top             =   150
      Width           =   1620
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuOpenContainer 
         Caption         =   "Open container..."
      End
      Begin VB.Menu mnuOutputPath 
         Caption         =   "Output path..."
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuMode 
      Caption         =   "Mode"
      Begin VB.Menu mnuUnpacker 
         Caption         =   "Unpacker"
      End
      Begin VB.Menu mnuPacker 
         Caption         =   "Packer"
         Checked         =   -1  'True
      End
   End
End
Attribute VB_Name = "frmUnpacker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Wave file steganography packer/unpacker.
' frmUnpacker.frm - unpacker module.
'  Krivous Anatolii Anatolevich (The trick), 2015

Option Explicit

Private Declare Sub CopyMemory _
                    Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

' // Choose the destination folder for the unpacking
Private Sub cmdPath_Click()
    Dim f As String
    
    f = BrowseFolder(Me.Hwnd)
    
    If Len(f) Then
        txtPath = f
    End If
    
End Sub

' // Open the container file
Private Sub cmdContainer_Click()
    Dim f As String
    
    f = ShowOpen(Me.Hwnd, "*.*")
    
    If Len(f) Then
        txtSource.Text = f
    End If
    
End Sub

' // Launch packing
Private Sub cmdRun_Click()
    Dim fNum    As Long:    Dim Ln      As Long:    Dim i           As Long:    Dim N       As Long
    Dim bits    As Long:    Dim Title   As String:  Dim NamePreset  As Boolean: Dim Dat()   As Byte
    Dim Pat     As Long:    Dim Mask()  As Integer: Dim Div()       As Long:    Dim Cyc As Long
    Dim Value   As Long:    Dim p       As Long:    Dim FileName    As String
    ' // Get the bitness
    bits = cboBits.ListIndex
    ' // Try to read the wave file
    If Not modWaveFile.ReadWaveFile(txtSource.Text) Then Exit Sub
    ' // Check the file length. It should be as least 6 bytes.
    If UBound(modWaveFile.WaveData) < 6 * -Int(-8 / (bits + 1)) Then MsgBox ("Ivalid file length"): Exit Sub
    ' // Fill the arrays of mask and dividers
    ' // Masks and diveders - 8 bit
    ReDim Mask(7):  ReDim Div(7)
    ' // 2 ^ 1 (1 shift)
    N = 1
    For i = 0 To 7
        ' // It is the number in order to obtain the necessary shift when it'll divide
        Div(i) = N
        ' // It is the mask that clears the necessary bits
        Mask(i) = -N * 2
        N = N * 2
    Next
    i = 0: N = 0: p = 0
    ' // Buffer for the file length
    ReDim Dat(3)
    ' // File cycle
    Do
        ' // Extract the necessary bits
        Value = modWaveFile.WaveData(N) And (Not Mask(bits))
        Pat = Pat Or (Value * Div(Cyc))
        ' // Add the bit offset
        Cyc = Cyc + (bits + 1)
        
        If Cyc > 7 Then
            ' // Extract the remainder
            Cyc = (Cyc And 7)
            ' // If it is the 4 bytes at the beginning it is the file size
            If i < 4 Then
                Dat(i) = Pat And &HFF&
                If i = 3 Then
                    CopyMemory Ln, Dat(0), 4
                    If Ln <= 0 Then MsgBox "Invalid file size": Exit Sub
                    ' // Alloc memory for the file data
                    ReDim Dat(Ln - 1)
                End If
            ' // If it is the next bytes after 4 bytes it is the file name
            ElseIf Not NamePreset Then
                If (Pat And &HFF) = 0 Then
                    ' // Does file fit into the space of container?
                    If -Int(-Ln / (bits + 1)) * 8 > (UBound(modWaveFile.WaveData) - N + 1) Then MsgBox "Incorrect file size": Exit Sub
                    NamePreset = True       ' /0
                Else
                    Title = Title & Chr$(Pat And &HFF&)
                End If
            Else
                Dat(p) = Pat And &HFF&
                p = p + 1
                ' // End of file
                If p > UBound(Dat) Then Exit Do
            End If
            ' // Next byte
            i = i + 1
            ' // Shift to 8 bits to right
            Pat = Pat \ &H100
        End If
        N = N + 1
    Loop
    
    fNum = FreeFile
    ' // Create file and write data to it
    FileName = txtPath.Text & "\" & Title
    ' // If file already exists
    If Len(Dir(FileName)) Then If MsgBox("File already exist. Overwrite?", vbQuestion Or vbYesNo) = vbNo Then Exit Sub
    Open FileName For Binary As fNum
    Put fNum, , Dat()
    Close fNum

End Sub

Private Sub Form_Load()
    cboBits.ListIndex = 4
End Sub

' // Menu handlers
Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuOpenContainer_Click()
    cmdContainer_Click
End Sub

Private Sub mnuOutputPath_Click()
    cmdPath_Click
End Sub

Private Sub mnuPacker_Click()
    Unload Me
    frmPacker.Show
End Sub
